#include"Image.h"

Image::~Image()
{
	delete[] pixels;  //dynamically free memory
}

Image::Image(char fileName[])
{
	ifstream fin(fileName, ios_base::binary );
	fileHeader.ReadFromFile(fin);
	imageHeader.ReadFromFile(fin);
	pixels = new Pixel[imageHeader.width * imageHeader.height]; //dynamic memory allocation
	int garbageBytesPerRow = imageHeader.width % 4;
	//read the pixels

	//int bytesRead = 0;
	for(unsigned int i = 0; i < imageHeader.width * imageHeader.height;i++)
	{
		fin.read((char*)&(pixels[i].blue),1);
		fin.read((char*)&(pixels[i].green),1);
		fin.read((char*)&(pixels[i].red),1);
		//bytesRead += 3;

		if((i+1) % imageHeader.width == 0)
		{
			//are at the end of a row
			//read garbage bytes  - garbageBytesPerRow
			char garbage[3];
			fin.read(garbage,garbageBytesPerRow);

			/*while(bytesRead % 4 != 0)
			{
				char garbarge;
				fin.read(&garbarge,1);
				bytesRead++;
			}
			bytesRead = 0;*/
		}
	}
}

void  Image::invertColors()
{
	for(unsigned int i = 0; i < imageHeader.width * imageHeader.height;i++)
	{
		pixels[i].blue = 255 - pixels[i].blue;
		pixels[i].green = 255 - pixels[i].green;
		pixels[i].red = 255 - pixels[i].red;
	}
}

void Image::flipHorizontal()
{
	for(int row = 0; row < imageHeader.height; row++)
	{
		for(int column = 0; column < imageHeader.width/2; column++)
		{
			int leftIndex = row * imageHeader.width + column;
			int rightIndex = row * imageHeader.width + (imageHeader.width - column - 1);
			//swap the pixels
			Pixel temp = pixels[leftIndex];
			pixels[leftIndex] = pixels[rightIndex];
			pixels[rightIndex] = temp;
		}
	}
}

void Image::save(char fileName[])
{
	ofstream fout(fileName, ios_base::binary );
	fileHeader.WriteToFile(fout);
	imageHeader.WriteToFile(fout);
	int garbageBytesPerRow = imageHeader.width % 4;

	//write pixels
	for(unsigned int i = 0; i < imageHeader.width * imageHeader.height;i++)
	{
		fout.write((char*)&(pixels[i].blue),1);
		fout.write((char*)&(pixels[i].green),1);
		fout.write((char*)&(pixels[i].red),1);

		if((i+1) % imageHeader.width == 0)
		{
			//are at the end of a row
			//write garbage bytes  - garbageBytesPerRow
			char garbage[3]= {0,0,0};
			fout.write(garbage,garbageBytesPerRow);
		}
	}

}
